diff --git a/src/main/java/net/minecraft/client/render/WorldRenderer.java b/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 3af796da9..52c76cafb 100644
--- a/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -2,21 +2,30 @@ package net.minecraft.client.render;
 
 import java.util.List;
 import java.util.Random;
-import net.minecraft.client.Minecraft;
-import net.minecraft.client.entity.player.EntityPlayerSP;
-import net.minecraft.client.render.camera.CameraUtil;
-import net.minecraft.client.render.camera.EntityCamera;
-import net.minecraft.client.render.camera.*;
-import net.minecraft.client.render.culling.Frustum;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.util.glu.GLU;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.entity.fx.EntityRainFX;
+import net.minecraft.client.entity.fx.EntitySmokeFX;
+import net.minecraft.client.entity.player.EntityPlayerSP;
 import net.minecraft.client.gui.GuiPhotoMode;
+import net.minecraft.client.gui.modelviewer.GuiModelViewer;
 import net.minecraft.client.input.InputType;
 import net.minecraft.client.input.MouseFilter;
 import net.minecraft.client.input.PlayerInput;
+import net.minecraft.client.render.camera.CameraUtil;
+import net.minecraft.client.render.camera.EntityCamera;
+import net.minecraft.client.render.camera.EntityCameraFirstPerson;
+import net.minecraft.client.render.camera.EntityCameraIsometric;
+import net.minecraft.client.render.camera.EntityCameraSleeping;
+import net.minecraft.client.render.camera.EntityCameraThirdPersonFront;
+import net.minecraft.client.render.camera.EntityCameraThirdPersonRear;
+import net.minecraft.client.render.culling.Frustum;
+import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.tessalator.TessellatorStandard;
 import net.minecraft.client.render.window.GameWindowLWJGL2;
 import net.minecraft.client.util.debug.Debug;
 import net.minecraft.client.world.chunk.provider.ChunkProviderStatic;
@@ -25,8 +34,6 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.client.entity.fx.EntityRainFX;
-import net.minecraft.client.entity.fx.EntitySmokeFX;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
@@ -41,9 +48,12 @@ import net.minecraft.core.world.weather.Weather;
 public class WorldRenderer
 {
     public static final long nsPerSecond = 1_000_000_000L;
+    public final LightmapHelper lightmapHelper;
 
     public WorldRenderer(Minecraft minecraft)
     {
+    	this.mc = minecraft;
+    	this.lightmapHelper = new LightmapHelper(minecraft, this);
         farPlaneDistance = 0.0F;
         pointedEntity = null;
         mouseFilterXAxis = new MouseFilter();
@@ -71,7 +81,6 @@ public class WorldRenderer
         rainSoundCounter = 0;
         field_1394_b = 0;
         field_1393_c = 0;
-        mc = minecraft;
         itemRenderer = new ItemRenderer(minecraft);
         fogManager = new FogManager(mc);
     }
@@ -410,6 +419,8 @@ public class WorldRenderer
         }
         return minFOV + 2 * (currentFov - minFOV) * logisticFunc(_zoom);
     }
+    
+    
     private float logisticFunc(float val){
         final float L = 1;
         final float k = 1.1f;
@@ -419,6 +430,7 @@ public class WorldRenderer
 
     public void updateCameraAndRender(float partialTick)
     {
+    	lightmapHelper.update(partialTick);
         if(mc.inGameHasFocus)
         {
 			if(Mouse.isGrabbed()) {
@@ -622,7 +634,7 @@ public class WorldRenderer
         setupCameraTransform(partialTick);
         Frustum.getFrustum();
         Debug.change("sky");
-        if(mc.gameSettings.renderDistance.value.renderSky)
+        if(mc.gameSettings.renderDistance.value.renderSky && !(mc.currentScreen instanceof GuiModelViewer))
         {
             fogManager.setupFog(FogManager.FOG_MODE_SKY, farPlaneDistance, partialTick);
             GL11.glDisable(GL11.GL_FOG);
@@ -663,7 +675,9 @@ public class WorldRenderer
         Lighting.disable();
 
         Debug.change("terrain");
+        lightmapHelper.enableLightmapRendering();
         renderGlobal.sortAndRender(mc.activeCamera, 0, partialTick);
+        lightmapHelper.disableLightmapRendering();
 
         Debug.change("entities");
         GL11.glShadeModel(7424 /*GL_FLAT*/);
@@ -720,6 +734,7 @@ public class WorldRenderer
             GL11.glColorMask(true, true, true, true);
             if(i1 > 0)
             {
+                lightmapHelper.enableLightmapRendering();
                 if (!mc.gameSettings.fog.value)
                 {
                     GL11.glDisable(GL11.GL_FOG);
@@ -729,12 +744,15 @@ public class WorldRenderer
                 {
                     GL11.glEnable(GL11.GL_FOG);
                 }
+                lightmapHelper.disableLightmapRendering();
             }
             GL11.glShadeModel(GL11.GL_FLAT);
         }
         else
         {
+        	lightmapHelper.enableLightmapRendering();
             renderGlobal.sortAndRender(mc.activeCamera, 1, partialTick);
+            lightmapHelper.disableLightmapRendering();
         }
         
         Debug.change("weather");
@@ -758,7 +776,7 @@ public class WorldRenderer
             setupPlayerCamera(partialTick);
         }
 
-        GL11.glColorMask(true, true, true, false);
+        GL11.glColorMask(true, true, true, true);
         Debug.pop();
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java
index 8b5ecff40..c8bccb950 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render.block.model;
 
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.tessalator.Tessellator;
 import net.minecraft.client.render.stitcher.IconCoordinate;
@@ -15,7 +16,12 @@ public class BlockModelAlgae<T extends Block> extends BlockModelStandard<T>{
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
         block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
-        float brightness = Math.min(getBlockBrightness(renderBlocks.blockAccess, x, y - 1, z), getBlockBrightness(renderBlocks.blockAccess, x, y, z));
+        float brightness = 1.0f;
+        if(!LightmapHelper.isLightmapEnabled()) {
+        	brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+        }else {
+        	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
+        }
 
         int color = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(renderBlocks.blockAccess, x, y, z);
         float red = (float)(color >> 16 & 0xff) / 255F;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java
index 71d700e1b..63c4ccf27 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.tessalator.Tessellator;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
@@ -30,7 +31,12 @@ public class BlockModelCropsPumpkin<T extends Block> extends BlockModelStandard<
     public boolean render(Tessellator tessellator, int x, int y, int z) {
         block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
 
-        final float brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+        float brightness = 1.0f;
+        if(LightmapHelper.isLightmapEnabled()) {
+        	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
+        }else {
+        	brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+        }
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
 
         final int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java
index 98702a48c..b9d899708 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.tessalator.Tessellator;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
@@ -26,7 +27,12 @@ public class BlockModelCropsWheat<T extends Block> extends BlockModelStandard<T>
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
         block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
-        float brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+        float brightness = 1.0f;
+        if(LightmapHelper.isLightmapEnabled()) {
+        	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
+        }else {
+        	brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+        }
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
 
         IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.BOTTOM, renderBlocks.blockAccess.getBlockMetadata(x, y, z));
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
index 0ae77411c..9f2e13215 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render.block.model;
 
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.tessalator.Tessellator;
 import net.minecraft.client.render.stitcher.IconCoordinate;
@@ -76,8 +77,14 @@ public class BlockModelCrossedSquares<T extends Block> extends BlockModelStandar
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
         block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
-
-        float brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+        
+        float brightness = 1.0f;
+        if(!LightmapHelper.isLightmapEnabled()) {
+        	brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+        }else {
+        	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
+        }
+        
         int color = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(renderBlocks.blockAccess, x, y, z);
         float r = (float)(color >> 16 & 0xff) / 255F;
         float g = (float)(color >> 8 & 0xff) / 255F;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 9448bae27..dad6f9dc5 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -383,6 +383,7 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelPortal<>(Block.portalParadise).withTextures("minecraft:block/portal_nether"));
 
         addDispatch(new BlockModelCake<>(Block.cake).withTextures("minecraft:block/cake_top", "minecraft:block/cake_bottom", "minecraft:block/cake_side"));
+        addDispatch(new BlockModelPumpkinPie<>(Block.pumpkinPie).withTextures("minecraft:block/pumpkin_pie_top", "minecraft:block/pumpkin_pie_bottom", "minecraft:block/pumpkin_pie_side"));
 
         addDispatch(new BlockModelLamp<>(Block.lampIdle));
         addDispatch(new BlockModelLamp<>(Block.lampActive));
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
index ae120f600..092f5f9d9 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
@@ -1,7 +1,9 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.tessalator.Tessellator;
+import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.tessalator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockDoor;
 import net.minecraft.core.util.helper.Side;
@@ -10,102 +12,94 @@ public class BlockModelDoor<T extends BlockDoor> extends BlockModelStandard<T>{
     public BlockModelDoor(Block block) {
         super(block);
     }
-
-    @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
-        float f = 0.5F;
-        float f1 = 1.0F;
-        float f2 = 0.8F;
-        float f3 = 0.6F;
-        float f4 = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
-        float f5 = getBlockBrightness(renderBlocks.blockAccess, x, y - 1, z);
-        boolean aboveIsDoor = renderBlocks.blockAccess.getBlock(x, y + 1, z) instanceof BlockDoor;
-        boolean belowIsDoor = renderBlocks.blockAccess.getBlock(x, y - 1, z) instanceof BlockDoor;
-        int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
-        if(block.minY > 0.0D)
-        {
-            f5 = f4;
-        }
-        if(Block.lightEmission[block.id] > 0)
-        {
-            f5 = 1.0F;
-        }
-        tessellator.setColorOpaque_F(f * f5, f * f5, f * f5);
-        if (!belowIsDoor){
-            renderBottomFace(tessellator, block, x, y, z, getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.BOTTOM));
-        }
-        f5 = getBlockBrightness(renderBlocks.blockAccess, x, y + 1, z);
-        if(block.maxY < 1.0D)
-        {
-            f5 = f4;
-        }
-        if(Block.lightEmission[block.id] > 0)
-        {
-            f5 = 1.0F;
-        }
-        tessellator.setColorOpaque_F(f1 * f5, f1 * f5, f1 * f5);
-        if (!aboveIsDoor){
-            renderTopFace(tessellator, block, x, y, z, getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.TOP));
-        }
-        f5 = getBlockBrightness(renderBlocks.blockAccess, x, y, z - 1);
-        if(block.minZ > 0.0D)
-        {
-            f5 = f4;
-        }
-        if(Block.lightEmission[block.id] > 0)
-        {
-            f5 = 1.0F;
-        }
-        tessellator.setColorOpaque_F(f2 * f5, f2 * f5, f2 * f5);
-        renderBlocks.flipTexture = shouldFlipTexture(Side.NORTH, meta);
-        IconCoordinate texture = getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.NORTH);
-        renderNorthFace(tessellator, block, x, y, z, texture);
-        renderBlocks.flipTexture = false;
-        f5 = getBlockBrightness(renderBlocks.blockAccess, x, y, z + 1);
-        if(block.maxZ < 1.0D)
-        {
-            f5 = f4;
-        }
-        if(Block.lightEmission[block.id] > 0)
-        {
-            f5 = 1.0F;
-        }
-        tessellator.setColorOpaque_F(f2 * f5, f2 * f5, f2 * f5);
-        renderBlocks.flipTexture = shouldFlipTexture(Side.SOUTH, meta);
-        texture = getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.SOUTH);
-        renderSouthFace(tessellator, block, x, y, z, texture);
-        renderBlocks.flipTexture = false;
-        f5 = getBlockBrightness(renderBlocks.blockAccess, x - 1, y, z);
-        if(block.minX > 0.0D)
-        {
-            f5 = f4;
-        }
-        if(Block.lightEmission[block.id] > 0)
-        {
-            f5 = 1.0F;
-        }
-        tessellator.setColorOpaque_F(f3 * f5, f3 * f5, f3 * f5);
-        renderBlocks.flipTexture = shouldFlipTexture(Side.WEST, meta);
-        texture = getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.WEST);
-        renderWestFace(tessellator, block, x, y, z, texture);
-        renderBlocks.flipTexture = false;
-        f5 = getBlockBrightness(renderBlocks.blockAccess, x + 1, y, z);
-        if(block.maxX < 1.0D)
-        {
-            f5 = f4;
-        }
-        if(Block.lightEmission[block.id] > 0)
-        {
-            f5 = 1.0F;
-        }
-        tessellator.setColorOpaque_F(f3 * f5, f3 * f5, f3 * f5);
-        renderBlocks.flipTexture = shouldFlipTexture(Side.EAST, meta);
-        texture = getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.EAST);
-        renderEastFace(tessellator, block, x, y, z, texture);
-        renderBlocks.flipTexture = false;
-        return true;
+    
+    public void setBrightness(Tessellator tessellator, int x, int y, int z, float sideBrightness) {
+    	float brightness = sideBrightness;
+    	if(LightmapHelper.isLightmapEnabled()) {
+    		tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
+    	}else {
+    		brightness *= renderBlocks.getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+    	}
+    	tessellator.setColorOpaque_F(brightness, brightness, brightness);
     }
+    
+    @Override
+	public boolean render(Tessellator tessellator, int x, int y, int z) {
+    	if(LightmapHelper.isLightmapEnabled()) {
+    		tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 15));
+    	}
+    	tessellator.setColorOpaque_F(1.0f, 1.0f, 1.0f);
+    	
+		block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
+
+		float sideBottom = 0.5f;
+		float sideTop = 1.0f;
+		float sideNorthSouth = 0.8f;
+		float sideEastWest = 0.6f;
+		
+		boolean aboveIsDoor = renderBlocks.blockAccess.getBlock(x, y + 1, z) instanceof BlockDoor;
+		boolean belowIsDoor = renderBlocks.blockAccess.getBlock(x, y - 1, z) instanceof BlockDoor;
+
+		int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+		
+		// Bottom
+		if(!belowIsDoor) {
+			setBrightness(tessellator, x, y - 1, z, sideBottom);
+			renderBottomFace(tessellator, block, x, y, z, getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.BOTTOM));
+		}
+		
+		// Top
+		if(!aboveIsDoor) {
+			setBrightness(tessellator, x, y + 1, z, sideTop);
+			renderTopFace(tessellator, block, x, y, z, getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.TOP));
+		}
+		
+		// North
+		if(block.minZ > RenderBlocks.FULL_CUBE_THRESHOLD) {
+			setBrightness(tessellator, x, y, z, sideNorthSouth);
+		}else {
+			setBrightness(tessellator, x, y, z - 1, sideNorthSouth);
+		}
+		renderBlocks.flipTexture = shouldFlipTexture(Side.NORTH, meta);
+		IconCoordinate texture = getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.NORTH);
+		renderNorthFace(tessellator, block, x, y, z, texture);
+		renderBlocks.flipTexture = false;
+		
+		// South
+		if(block.maxZ < 1.0f - RenderBlocks.FULL_CUBE_THRESHOLD) {
+			setBrightness(tessellator, x, y, z, sideNorthSouth);
+		}else {
+			setBrightness(tessellator, x, y, z + 1, sideNorthSouth);
+		}
+		renderBlocks.flipTexture = shouldFlipTexture(Side.SOUTH, meta);
+		texture = getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.SOUTH);
+		renderSouthFace(tessellator, block, x, y, z, texture);
+		renderBlocks.flipTexture = false;
+		
+		// West
+		if(block.minX > RenderBlocks.FULL_CUBE_THRESHOLD) {
+			setBrightness(tessellator, x, y, z, sideEastWest);
+		}else {
+			setBrightness(tessellator, x - 1, y, z, sideEastWest);
+		}
+		renderBlocks.flipTexture = shouldFlipTexture(Side.WEST, meta);
+		texture = getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.WEST);
+		renderWestFace(tessellator, block, x, y, z, texture);
+		renderBlocks.flipTexture = false;
+		
+		// East
+		if(block.maxX < 1.0f - RenderBlocks.FULL_CUBE_THRESHOLD) {
+			setBrightness(tessellator, x, y, z, sideEastWest);
+		}else {
+			setBrightness(tessellator, x + 1, y, z, sideEastWest);
+		}
+		renderBlocks.flipTexture = shouldFlipTexture(Side.EAST, meta);
+		texture = getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.EAST);
+		renderEastFace(tessellator, block, x, y, z, texture);
+		renderBlocks.flipTexture = false;
+		return true;
+	}
+    
     @Override
     public boolean shouldItemRender3d() {
         return false;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
index 368e5aa3d..a99bbb4f8 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.tessalator.Tessellator;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
@@ -24,7 +25,13 @@ public class BlockModelFenceThin<T extends BlockFenceThin> extends BlockModelSta
     @Override
     public boolean render(Tessellator t, int x, int y, int z) {
         block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
-        float brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+        float brightness = 1.0f;
+        if(LightmapHelper.isLightmapEnabled()) {
+        	t.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
+        }else {
+        	brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+        }
+        t.setColorOpaque_F(brightness, brightness, brightness);
 
         float cBottom = 0.5F;
         float cTop = 1.0F;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
index 1130c10e5..793688b95 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render.block.model;
 
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.tessalator.Tessellator;
 import net.minecraft.client.render.stitcher.IconCoordinate;
@@ -34,10 +35,12 @@ public class BlockModelFluid<T extends Block> extends BlockModelStandard<T> {
             return false;
         }
         boolean didRender = false;
-        float f3 = 0.5F;
-        final float brightness = 1.0F;
-        float f5 = 0.8F;
-        float f6 = 0.6F;
+        
+        final float sideBottom = 0.5f;
+        final float sideTop = 1.0f;
+        final float sideNorthSouth = 0.8f;
+        final float sideEastWest = 0.6f;
+        
         double d = 0.0D;
         double d1 = 1.0D;
         final float yOff = 0.001f;
@@ -58,10 +61,15 @@ public class BlockModelFluid<T extends Block> extends BlockModelStandard<T> {
             } else {
                 rotation = 0.0F;
             }
-//            if (MathHelper.PI < rotation && rotation < (MathHelper.PI/2) * 3){
-//                rotation -= MathHelper.PI/2;
-//            }
-            float blockBrightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+            float blockBrightness = 1.0f;
+            if(LightmapHelper.isLightmapEnabled()) {
+            	int light = block.getLightmapCoord(renderBlocks.blockAccess, x, y, z);
+            	int lightUp = block.getLightmapCoord(renderBlocks.blockAccess, x, y + 1, z);
+            	
+            	tessellator.setLightmapCoord(LightmapHelper.max(light, lightUp));
+            }else {
+            	blockBrightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+            }
             if (texture.namespaceId.contains("_flowing")){
                 double centerU = texture.getSubIconU(0.5);
                 double centerV = texture.getSubIconV(0.5);
@@ -71,13 +79,13 @@ public class BlockModelFluid<T extends Block> extends BlockModelStandard<T> {
                 double maxU = texture.getIconUMax();
                 double minV = texture.getIconVMin();
                 double maxV = texture.getIconVMax();
-                tessellator.setColorOpaque_F(brightness * blockBrightness * r, brightness * blockBrightness * g, brightness * blockBrightness * b);
+                tessellator.setColorOpaque_F(sideTop * blockBrightness * r, sideTop * blockBrightness * g, sideTop * blockBrightness * b);
                 tessellator.addVertexWithUV(x,      (float)y + f7,      z,      ((minU - centerU) * sin - (maxV - centerV) * cSin) + centerU, ((maxV - centerV) * sin + (minU - centerU) * cSin) + centerV);
                 tessellator.addVertexWithUV(x,      (float)y + f8,      z + 1,  ((maxU - centerU) * sin - (maxV - centerV) * cSin) + centerU, ((maxV - centerV) * sin + (maxU - centerU) * cSin) + centerV);
                 tessellator.addVertexWithUV(x + 1,  (float)y + f9,      z + 1,  ((maxU - centerU) * sin - (minV - centerV) * cSin) + centerU, ((minV - centerV) * sin + (maxU - centerU) * cSin) + centerV);
                 tessellator.addVertexWithUV(x + 1,  (float)y + f10,     z,      ((minU - centerU) * sin - (minV - centerV) * cSin) + centerU, ((minV - centerV) * sin + (minU - centerU) * cSin) + centerV);
             } else {
-                tessellator.setColorOpaque_F(brightness * blockBrightness * r, brightness * blockBrightness * g, brightness * blockBrightness * b);
+                tessellator.setColorOpaque_F(sideTop * blockBrightness * r, sideTop * blockBrightness * g, sideTop * blockBrightness * b);
                 tessellator.addVertexWithUV(x,      (float)y + f7,      z,      texture.getIconUMin(), texture.getIconVMax());
                 tessellator.addVertexWithUV(x,      (float)y + f8,      z + 1,  texture.getIconUMax(), texture.getIconVMax());
                 tessellator.addVertexWithUV(x + 1,  (float)y + f9,      z + 1,  texture.getIconUMax(), texture.getIconVMin());
@@ -87,8 +95,13 @@ public class BlockModelFluid<T extends Block> extends BlockModelStandard<T> {
         }
         if(renderBlocks.renderAllFaces || flag1)
         {
-            float f11 = getBlockBrightness(renderBlocks.blockAccess, x, y - 1, z);
-            tessellator.setColorOpaque_F(f3 * f11 * r, f3 * f11 * g, f3 * f11 * b);
+            float brightness = 1.0f;
+            if(LightmapHelper.isLightmapEnabled()) {
+            	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y - 1, z));
+            }else {
+            	brightness = getBlockBrightness(renderBlocks.blockAccess, x, y - 1, z);
+            }
+            tessellator.setColorOpaque_F(sideBottom * brightness * r, sideBottom * brightness * g, sideBottom * brightness * b);
 
             renderBlocks.renderBottomFace(tessellator, block,x, y + yOff, z, getBlockTextureFromSideAndMetadata(Side.TOP, 0));
             didRender = true;
@@ -173,15 +186,18 @@ public class BlockModelFluid<T extends Block> extends BlockModelStandard<T> {
             double d6 = texture.getSubIconV(0.5F - f13/2 + vOff);
             double d7 = texture.getSubIconV(0.5F - f15/2 + vOff);
             double d8 = texture.getSubIconV(0.5F + vOff);
-            float f22 = getBlockBrightness(renderBlocks.blockAccess, xB, yB, zB);
-            if(side < 2)
-            {
-                f22 *= f5;
-            } else
-            {
-                f22 *= f6;
-            }
-            tessellator.setColorOpaque_F(brightness * f22 * r, brightness * f22 * g, brightness * f22 * b);
+			float brightness = 1.0f;
+			if(LightmapHelper.isLightmapEnabled()) {
+				tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, xB, yB, zB));
+			}else {
+				brightness = getBlockBrightness(renderBlocks.blockAccess, xB, yB, zB);
+			}
+			if(side < 2) {
+				brightness *= sideNorthSouth;
+			}else {
+				brightness *= sideEastWest;
+			}
+            tessellator.setColorOpaque_F(sideTop * brightness * r, sideTop * brightness * g, sideTop * brightness * b);
             tessellator.addVertexWithUV(f17, (float)y + f13, f19, d4, d6);
             tessellator.addVertexWithUV(f20, (float)y + f15, f21, d5, d7);
             tessellator.addVertexWithUV(f20, y, f21, d5, d8);
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java
index db427f2a5..199e36389 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.tessalator.Tessellator;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
@@ -19,8 +20,13 @@ public class BlockModelLadder<T extends Block> extends BlockModelStandard<T> {
         {
             l = renderBlocks.overrideBlockTexture;
         }
-        float f = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
-        tessellator.setColorOpaque_F(f, f, f);
+        float brightness = 1.0f;
+        if(!LightmapHelper.isLightmapEnabled()) {
+        	brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+        }else {
+        	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
+        }
+        tessellator.setColorOpaque_F(brightness, brightness, brightness);
         double d = l.getIconUMin();
         double d1 = l.getIconUMax();
         double d2 = l.getIconVMin();
